const Parameter = require('./Parameter');

class StoredProcedure {
  prepare(name, params) {
    try {
      const paramNames = [];
      const procedureParams = params.reduce((procParams, param) => {
        const newParam = Parameter.create(param);
        procParams[param.name] = newParam;
        paramNames.push(`:${param.name}`);
        return procParams;
      }, {});
      const sql = `BEGIN
        ${name}(${paramNames.join(', ')});
      END;`;
      return { sql, params: procedureParams }
    } catch (error) {
      return Promise.reject(new Error('DB_ERROR'));
    }
  }
}

module.exports = new StoredProcedure()