class Messages {
  #messages = {
    MONITORING_ERR_RESULT_UNIT: 'Filial: {{CDFILIAL}} | {{TYPE}} ERR: {{ID}} - {{NAME}} | MSG: {{MSG}}'
  }

  get messages() {
    return this.#messages;
  }

  set messages(value) {
    throw new Error('Operation "set" not permitted');
  }

  replaceParams(text, parameters) {
    const mnemonics = text.match(/{{\w+}}/g) || [];
    if(!parameters) return text;
    return mnemonics.reduce((message, mnemonic) => {
      const keyRegex = new RegExp(mnemonic, 'g');
      const key = mnemonic.match(/\w+/g);
      return message.replace(keyRegex, info[key] || '');
    }, text);
  }

  get(code, parameters = {}) {
    const message = this.#messages[code] || code;
    return this.replaceParams(message, parameters);
  }
}

module.exports = new Messages();