const UpdaterServicoFili = require("../model/UpdaterServicoFili");
const UpdaterServicoCx = require("../model/UpdaterServicoCx");

class UpdaterServiceMonitoring {
  getModelByParams(params) {
    return params.CDCAIXA || params.P_CDCAIXA ? UpdaterServicoCx : UpdaterServicoFili;
  }

  insert(params, executionParams = {}) {
    const model = this.getModelByParams(params);
    return model.insert(params, executionParams);
  }

  update(params, executionParams = {}) {
    const model = this.getModelByParams(params);
    return model.update(params, executionParams);
  }

  getServiceMonitoring(params, executionParams = {}) {
    const model = this.getModelByParams(params);
    return model.getServiceMonitoring(params, executionParams);
  }

  getMonitoredUnits(params = {}, executionParams = {}) {
    const model = this.getModelByParams(params);
    return model.getMonitoredUnits(params, executionParams);
  }

  getServiceMonitoringWithCasher(params) {
    return UpdaterServicoCx.getServiceMonitoringWithCasher(params);
  }
}

module.exports = new UpdaterServiceMonitoring();