const md5 = require('md5');
const Operador = require('../model/Operador');
const jwt = require('../functions/JsonWebToken');
const AccessProfile = require('../service/AccessProfile');

const route = (router) => {
  router.post('/login', (async (req, res) => {
    try {
      const { email, password } = req.body;
      const encryptedPassword = md5(password);
      const loginData = await Operador.getUserByCredentials({ EMAIL: email, PASSWORD: encryptedPassword });

      if (loginData.rows.length === 0) {
        throw 'INVALID_EMAIL_OR_PASSWORD';
      }

      const operator = loginData.rows[0];
      if (operator.IDOPERATIVO !== 'A') {
        throw 'OPERATOR_INACTIVE';
      }
      const accessProfile = await AccessProfile.getAccessProfile({ CDOPERADOR: operator.CDOPERADOR });
      operator.ACCESS_PROFILE = accessProfile;
      operator.TOKEN = jwt.sign(operator);
      res.send(operator);
    } catch (error) {
      res.status(500).send({ message: typeof error === 'string' ? error : error.message });
    }
  }));
}

module.exports = route;