class MonitoringData {
  static data = {};

  getUniqueKey({ unit, casher }) {
    const key = casher ? `${unit}_${casher}` : unit;
    return key;
  }

  add(infoData, { id, unit, casher = null }) {
    const key = this.getUniqueKey({ unit, casher });
    MonitoringData.data[key] = MonitoringData.data[key] || {};
    MonitoringData.data[key][id] = { ...infoData };
  }

  remove({ id, unit, casher = null }) {
    const key = this.getUniqueKey({ unit, casher });
    if (MonitoringData.data[key] && MonitoringData.data[key][id]) {
      delete MonitoringData.data[key][id];
    }
  }

  get({ id, unit, casher = null }) {
    const key = this.getUniqueKey({ unit, casher });
    if (MonitoringData.data[key] && MonitoringData.data[key][id]) {
      return MonitoringData.data[key][id];
    }
    return null;
  }

  getAllData() {
    return MonitoringData.data;
  }

  getSummary() {
    const dataset = MonitoringData.data;
    return Object.keys(dataset).reduce((response, key) => {
      const [ unit, casher = null ] = key.split('_');
      response[unit] = {};
      let refObj = response[unit];
      if (casher) {
        response[unit][casher] = {};
        refObj = response[unit][casher];
      }
      Object.keys(dataset[key]).forEach((monitorId) => {
          const { STATUS, QTDERROR } = dataset[key][monitorId];
          refObj[monitorId] = STATUS;
          refObj.QTDERROR = refObj.QTDERROR || {};
          refObj.QTDERROR[monitorId] = QTDERROR.toString();
      });
      return response;
    }, {});
  }

  clear() {
    MonitoringData.data = {};
  }
 }

module.exports = new MonitoringData();