const io = require("socket.io");

class SocketManager {
  static conn;

  connect(serverHttp) {
    SocketManager.conn = io(serverHttp, { cors: "*" });
  }

  getSocketIo() {
    return SocketManager.conn;
  }

  getRoom(roomName) {
    return this.getSocketIo().to(roomName);
  }
 
  getQueryParams(socket) {
    const defaults = {
        page: '',
    };
    const { query } = socket.handshake;
    return ({
        ...defaults,
        ...query
    });
  }

  getSocketHeaderInfo(socket) {
      let { headers } = socket.handshake;
      const defaults = {
          agent: "",
          cdfilial: "",
          cdcaixa: "",
          hostname: "",
          version: "",
          origin: "",
          "user-agent": "",
          "x-real-ip": socket.handshake.address,
      };
      let { agent, cdfilial, cdcaixa, hostname, version, origin, ...others } = {
          ...defaults,
          ...headers,
      };
      let ip = others["x-real-ip"];
      let userAgent = others["user-agent"];
      let log = [agent, cdfilial, cdcaixa, hostname, ip]
          .filter((value) => value)
          .join(" | ");
      return { log, agent, cdfilial, cdcaixa, hostname, version, ip, userAgent, origin };
  }
}

module.exports = new SocketManager();