const StartupTasks = require('./app/main/StartupTasks');
const SystemLogger = require('./app/logs/SystemLogger');
const app = require('./app/main/app');
const http = require('http').createServer(app);

const port = process.argv[3];

if (port) {
  process.on('warning', e => console.warn(e.stack));
  StartupTasks.start(http).then(() => {
    http.listen(port, () => {
      console.log(`Running on ${port}!`);
    });
  }).catch(err => {
    SystemLogger.error(err);
  });
} else {
  console.log(
`Usage: node index.js <DB_NAME> <PORT>

Arguments:
  DB_NAME   Database Name (or EXTERNAL for local database)
  PORT      Port to up server`
  );

  process.exit(1);
}