class MessageHandler {
  message: any = {
      OPERATOR_INACTIVE: 'Operador inativo.',
      INVALID_EMAIL_OR_PASSWORD: 'Falha ao realizar autenticação. Usuário ou senha inválidos.',
      FAIL_AUTH_TRY_AGAIN: 'Falha ao autenticar o usuário/senha. Tente novamente.',
  };

  public getMessageByCode(code: string, params?: any) {
      let message: string = this.message.DEFAULT_MESSAGE_NOT_FOUND;
      if (code) {
          message = this.message[code] || code;
      }

      if (params) {
          const mnemonicArray = this.getMnemonicArray(message);

          mnemonicArray.forEach((mnemonic) => {
              const key = this.removeUnderscore(mnemonic);
              message = message.replace(new RegExp(mnemonic, 'g'), params[key]);
          });
      }

      return message;
  }

  private getMnemonicArray(string: string) {
      const regex = /__\w+__/gi;
      const matches = string.match(regex) || [];
      const uniqueMatches = [...new Set(matches)];

      return uniqueMatches;
  }

  private removeUnderscore(string: string) {
      const regex = /_/g;

      return string.replace(regex, '');
  }
}

export default new MessageHandler();
