import { AlertService } from '@zeedhi/common';

export class AddResponseFail {
  public static libInvalidToken() {
    localStorage.clear();
    const inLoginPage = window.location.pathname === '/login';
    if (!inLoginPage) {
      AlertService.show({
        name: 'error-info',
        text: 'Token de autenticação inválido/expirado. Redirecionando para a tela de login...',
        color: 'error',
        right: true,
        top: true,
      });
    }

    setTimeout(() => {
      if (!inLoginPage) {
        window.location.href = `${window.location.origin}/login`;
        window.location.reload();
      }
    }, 5000);
  }

  public static async libCommonError(errorText: string) {
    AlertService.show({
      name: 'error-info',
      text: errorText,
      color: 'error',
      right: true,
      top: true,
    });
  }
}
